local sti = require("lib.sti")

local map = {
    scale = 2
}

function map:load()
    self.map = sti("maps/testmap.lua")
    
    self.width = self.map.width * self.map.tilewidth * self.scale
    self.height = self.map.height * self.map.tileheight * self.scale

    local solidColliders = {}
    for i, obj in pairs(self.map.layers["Solids"].objects) do
        solidColliders.body = love.physics.newBody(world, (obj.x + obj.width/2) * self.scale, (obj.y + obj.height/2) * self.scale, "static")
        solidColliders.shape = love.physics.newRectangleShape(obj.width * self.scale, obj.height * self.scale)
        solidColliders.fixture = love.physics.newFixture(solidColliders.body, solidColliders.shape)
        solidColliders.fixture:setUserData("Solids")

        lightWorld:newRectangle((obj.x + obj.width/2) * self.scale, (obj.y + obj.height/2) * self.scale, obj.width * self.scale, obj.height * self.scale)

    end

    for i, obj in pairs(self.map.layers["Lights"].objects) do
        -- Add Shadow Boxes
    end
end

function map:draw()
    self.map:drawImageLayer("Map")
end

function map:update(dt)

    if camera.x < windowWidth/2 then
        camera.x = windowWidth/2
    end
    if camera.y < windowHeight/2 then
        camera.y = windowHeight/2
    end

    if camera.x > (self.width - windowWidth/2) then
        camera.x = (self.width - windowWidth/2)
    end
    if camera.y > (self.height - windowHeight/2) then
        camera.y = (self.height - windowHeight/2)
    end
end

return map